/**
 * FakeTapestryStage.
 *
 * @author	Gifford Cheung
 * @version	$Id: FakeTapestryStage.java,v 1.4 2001/11/30 03:34:44 hweather Exp $
 */  

//INDIVIDUAL FUNCTION TODOS:
// authentic(RouteTMessage msg) done by MacHandler
// send(RouteTMessage msg)
// blablbalException();
// doMAC(RouteTMessage msg); done by MacHandler
package ostore.mac;
import java.util.*;
import java.math.*;
import java.net.*;
import ostore.util.*;
import ostore.dispatch.*;
import ostore.tapestry.*;
import ostore.network.*;
import mdw.sandStorm.api.*;
import mdw.sandStorm.core.*;
import mdw.sandStorm.internal.SinkProxy;
/**
 * Fake Tapestry stage interfaces with MacHandler
 */
public class FakeTapestryStage implements EventHandlerIF, ProfilableIF {

	public static final boolean DEBUG = true;
	public MacHandler macHandler;


	public void handleEvent(QueueElementIF item)
		throws EventHandlerException {

		//Inbound, Verify it. and send along
		if (item instanceof MACMessage) {
			// NOTICE MACMessage is a RouteTMessage
			// so this is section should probably be in a different
			// spot depending on how you want to code
			MACMessage msg = (MACMessage) item;
			MACedQS inside = msg.message();
			try {
				if (macHandler.authenticate(inside, new SHA1Hash())) {
					send(inside.user_data());
				}
				else Carp.die("NOT AUTHENTIC");
			} catch (MacHandler.GuidNotEstablished e) {
				macHandler.establish(new SHA1Hash());
				_timer.registerEvent (1000, msg, _this_sink);
			}
		} else if (item instanceof RouteTMessage) {
			RouteTMessage msg = (RouteTMessage) item;
			if (!msg.usingMAC) {
				send(msg);
			} else {
				MACedQS m = new MACedQS(msg);
							
				try{
					// MAC it. and send along
					macHandler.doMAC(m, new SHA1Hash());
					MACMessage s = new MACMessage(msg.peer,
								      true,
								      m);
					
					send(s);
				} catch (MacHandler.GuidNotEstablished e) {
					//NOT ESTABLISHED WITH PERSON SO:
					//tell macHandler to request it
					//timer the message back to this stage
					macHandler.establish(new SHA1Hash());

					// in actual tapestry, probably want
					// to place inside internal
					// queue instead.
					_timer.registerEvent (2000, msg, _this_sink);
				}
			}
		}
	}

	public void handleEvents(QueueElementIF item[])
		throws EventHandlerException {
		for (int i = 0; i < item.length; i += 1)
				handleEvent(item[i]);
	}
	
	public void send(QuickSerializable msg) {}

	public void init(ConfigDataIF config) throws Exception {

		System.err.println("FakeTapestryStage initializing.------------");
		
		// this is required for function calls to the machandler.
		//macHandler = config.getManager().getMacHandler(); //TODO 
		//macHandler = MACDHHandler.getInstance();
		macHandler = new StubHandler();

		String stageName = config.getStage().getName();
		try 
		{
		  if(config.getBoolean("Profile"))
		  {
		    config.getManager().getProfiler().add("ostore.mac.FakeTapestryStage", this);
		    SinkIF sink =
		      config.getManager().getStage(stageName).getSink();
		    _this_sink = new SinkProxy(sink,
					       config.getManager(),
					       config.getStage().getWrapper());
		  }
		  else
		    _sink =
			config.getManager().getStage(stageName).getSink();
		} 
		catch (NoSuchStageException e) 
		{
		  Carp.die (stageName + ".init: could not get own sink.");
		}

		_timer = new ssTimer();


		// subscribe ourselves to certain types of messages
		// RouteTMessage (usingMAC verifiedMAC outbound) 
		Filter filter = new Filter();
		if (! filter.requireType (Class.forName
			("ostore.tapestry.RouteTMessage")))
			Carp.die ("FakeTapestryStage: could not require type.");
		Classifier.getClassifier().subscribe(filter, _this_sink);
		/**
		if (! filter.requireValue ("usingMAC", new Boolean (true)))
			Carp.die ("FakeTapestryStage: could not require usingMAC.");
		if (! filter.requireValue ("verifiedMAC", new Boolean (true)))
			Carp.die ("FakeTapestryStage: could not require verifiedMAC.");
		if (! filter.requireValue ("inbound", new Boolean (false)))
			Carp.die ("FakeTapestryStage: could not require outbound.");
		Classifier.getClassifier().subscribe(filter, _this_sink);

		// RouteTMessage (usingMAC !verifiedMAC inbound) 
		filter = new Filter();
		if (! filter.requireType (Class.forName
			("ostore.tapestry.RouteTMessage")))
			Carp.die ("FakeTapestryStage: could not require type.");
		if (! filter.requireValue ("inbound", new Boolean (true)))
			Carp.die ("FakeTapestryStage: could not require inbound.");
		Classifier.getClassifier().subscribe(filter, _this_sink);
		**/
		

		System.err.println("FakeTapestryStage Initiated.---------------");

	}
	
	public void destroy() throws Exception {
		//TODO
	}

        //  methods for ProfilableIF
        /* Specified by mdw.sandStorm.api.ProfilableIF */
        public int profileSize()
        {
	    return _this_sink.size();
        }
        //  end methods for ProfilableIF

	private SinkIF _this_sink;
	private ssTimer _timer;

}

				
		
