/**
 * MACMessage
 *
 * @author      Gifford Cheung
 * @version     $Id: MACMessage.java, v 1.0 2001/07/13 12:01:00 gkcheung Exp
 */

package ostore.mac;

import ostore.tapestry.*;
import ostore.util.*;
import ostore.security.*;
import mdw.sandStorm.api.*;
import javax.crypto.interfaces.*;

/**
 * RouteTMessage wrapper for use with MACedQS objects. For sending
 * a MACedQS over Tapestry...
 */
public class MACMessage extends RouteTMessage {
    
    public MACedQS msg;
    
    public MACMessage(SecureHash to, boolean e, MACedQS msg) {
        super(to, e);
        this.msg = msg;
    }

    public MACedQS message() { return msg; }

    /** 
     *  Generate MACMessage from data
     */
      public MACMessage (byte [] data, int [] offset) throws QSException {
        super(data, offset);
        msg = new MACedQS(data, offset);
        
      }

      public void to_bytes (byte [] data, int [] offset) {
        msg.to_bytes( data, offset);
      }

    public int type_code() {
        return Types.MAC_MACMESSAGE;
    }
}
