/**
 * PatchworkAlarmMsg.java
 *
 * @author Jeremy Stribling
 * @version    $Id: PatchworkAlarmMsg.java,v 1.1 2001/12/04 19:44:06 strib Exp $
 */

package ostore.oil.patchwork;

import mdw.sandStorm.api.QueueElementIF;

/**
 * This represents a command to the <code>PatchworkStage</code>
 * indicating that it's time to send out a probe of a certain type
 * to the appropriate nodes.
 *
 * @author Jeremy Stribling
 * @version    $Id: PatchworkAlarmMsg.java,v 1.1 2001/12/04 19:44:06 strib Exp $
 */
public class PatchworkAlarmMsg implements QueueElementIF {

    public static final int LATENCY = 0;
    public static final int BANDWIDTH = 1;
    public static final int LOSS = 2;
    public static final int RECALC_MODEL = 3;

    public int type;

    public PatchworkAlarmMsg( int type ) {

	if( (type != LATENCY) && (type != BANDWIDTH) && 
	    (type != LOSS) && (type != RECALC_MODEL) ) {
	  throw new RuntimeException( "Invalid type (" + type + 
				      ") for PatchworkAlarmMsg" ); 
	} else {
	  this.type = type;
	}
    }

    public String toString() {
	return "(PatchworkAlarmMsg, type " + type + 
	       " " + super.toString() + ")";
    }
}

