/**
 * PublishTMessage
 *
 * @author     Ben Y. Zhao
 * @version    $Id: PublishTMessage.java,v 1.3 2001/08/22 00:34:16 srhea Exp $
 */

package ostore.tapestry;
import ostore.util.*;
import mdw.sandStorm.api.*;

/****************
 * Event used to signal to Tapestry to advertise or publish a given object.
 */
public class PublishTMessage implements TEventIF {
  public static final int LOW_FREQ_PUBLISH = 0;
  public static final int HIGH_FREQ_PUBLISH = 1;
  
    /**
     * The Guid of the object we're publishing.
     */
    public SecureHash objGuid;

    /**
     * The redundancyLevel we want to publish with, defaults to system-wide
     * parameter.
     */
    public int redundancyLvl = Tapestry.LOCATION_REDUNDANCY;

    /** 
     * Specifying whether the object needs to be published with relatively
     * high frequency or relatively low frequency (for archival objects).
     * Defaults to high frequency.
     */
    public int publishRate = HIGH_FREQ_PUBLISH;

  public PublishTMessage(SecureHash oGuid) {
    objGuid = oGuid;
  }

  public PublishTMessage(SecureHash oGuid, int redLvl,
			 int pRate) {
    objGuid = oGuid;
    redundancyLvl = redLvl;
    publishRate = pRate;
  }

  public String toString() {
    return "(PublishTMessage "+super.toString()+")";
  }

}









