/**
 * Tapestry internal message for transferring data.<br>
 * To do -- <br>
 * payloads need to be fixed.
 * Debugging/testing
 *
 * @author     Scott Honey
 * @version    $Id
 */





package ostore.tapestry;

import java.util.*;
import java.net.*;
import ostore.util.*;
import ostore.dispatch.*;
import ostore.network.*;
import mdw.sandStorm.api.*;  //probably not needed.
import mdw.sandStorm.lib.aSocket.*; //probably not needed.



public class RouteDataMessage extends TapestryInternalMessage {

    protected QuickSerializable dataPayload;     


	//TODO make an entry in Types.java for this.

	/* obsolete.
	   static {
	   try {
	   TypeTable.register_type (new RouteDataMessage ());
	   }
	   catch (TypeTable.DuplicateTypeCode e) {
	   //Carp.die ("RouteDataMessage has duplicate type code.");
	   }
    }*/
    
    
    /** null constructor*/
    public RouteDataMessage(){
	
    }

    /**Typical constructor*/
    public RouteDataMessage(int typeCode, SHA1Hash source, SHA1Hash destination, NodeId nextHop, int hop, QuickSerializable data){
        
	super(ostore.util.Types.TAPESTRY_ROUTE_DATA_MESSAGE,source,destination,nextHop,hop);
	dataPayload = data;
    }
    
    
    /** Packs in the data payload on to of the TapestryInternalMessage format
	
	size (int)  //includes type code's length
	type code (int)
	data (byte[])
    */
    
    public int to_bytes( byte[] data, int offset){
	int old_offset = offset;
	offset += super.to_bytes (data, offset); //lots done by TapestryInternalMessage
	
	int size = dataPayload.to_bytes(null,0);
	
	offset += ByteUtils.intToBytes (size + 4, data, offset);
	offset += ByteUtils.intToBytes (dataPayload.type_code (), data, offset);
	offset += dataPayload.to_bytes (data, offset);
	
	return offset - old_offset;
    }
    


    /** unpacks the data payload on to of the TapestryInternalMessage format

	size (int)  //includes type code's length
	type code (int)
	data (byte[] -->QuickSerializable)
    */

    public int from_bytes (byte [] data, int offset) {
	int old_offset = offset;
	offset += super.from_bytes (data, offset);//lots done by TapestryInternalMessage
	
	int size =  ByteUtils.bytesToInt (data, offset);
	offset += 4;
	
	
	int typeCode;
	QuickSerializable payload;
	if (size >=4) {
	    typeCode = ByteUtils.bytesToInt (data, offset);
	    offset += 4;
	    
	    if (size >=5){

		/* TODO
		   some sort of switching based on type code to resurrect quick serializable
		   
		   dataPayload = payload;	       
		*/
		
	    }
	}//end if
	
	
	
	return offset - old_offset;
    }   
    
    

    public String toString(){
	return (super.toString() + " RouteDataMessage: Payload =  " +
		((dataPayload==null) ? "no payload" : dataPayload.toString()) + "\n" );
	
    }
    
}

