/**
 * TapestryLocationMsg.
 *
 * @author     Sean C. Rhea
 * @version    $Id: TapestryPublishMsg.java,v 1.3 2001/11/24 03:51:10 hweather Exp $
 */
package ostore.tapestry.api;
import ostore.util.SecureHash;
import ostore.util.QuickSerializable;
import mdw.sandStorm.api.QueueElementIF;

/**
 * Event that causes Tapestry to publish a backpointer to the given GUID
 * with the given tag.  
 *
 * @see TapestryLocateMsg
 */
public class TapestryPublishMsg implements QueueElementIF {

    /**
     * The GUID.
     */
    public SecureHash guid;

    /**
     * The tag.
     */
    public TapestryTag tag;

    /**
     * Construct according to the given fields.
     */
    public TapestryPublishMsg (SecureHash guid, TapestryTag tag) {

	this.guid = guid;
	this.tag = tag;
    }

    /**
     * Returns a human-readable representation of this
     * <code>TapestryPublishMsg</code>. */
    public String toString()
    {
      String str = new String();

      str += "<TapestryPublishMsg";
      str += " guid==" + guid;
      str += " tag==" + tag;
      str += ">";
      
      return str;
    }
}

