/**
 * TapestryUnpublishMsg
 *
 * @author     Ben Y. Zhao
 * @version    $Id: TapestryUnpublishMsg.java,v 1.1 2001/12/14 03:25:46 ravenben Exp $
 */

package ostore.tapestry.api;
import ostore.util.SecureHash;
import ostore.util.QuickSerializable;
import mdw.sandStorm.api.QueueElementIF;

/**
 * Event that causes Tapestry to remove published backpointers to the given
 * GUID with the given tag.  
 *
 * @see TapestryLocateMsg
 * @see TapestryPublishMsg
 */
public class TapestryUnpublishMsg implements QueueElementIF {

    /**
     * The GUID.
     */
    public SecureHash guid;

    /**
     * The tag.
     */
    public TapestryTag tag;

    /**
     * Construct according to the given fields.
     */
    public TapestryUnpublishMsg (SecureHash guid, TapestryTag tag) {
	this.guid = guid;
	this.tag = tag;
    }

    /**
     * Returns a human-readable representation of this
     * <code>TapestryUnpublishMsg</code>. */
    public String toString()
    {
      String str = new String();

      str += "<TapestryUnpublishMsg";
      str += " guid==" + guid;
      str += " tag==" + tag;
      str += ">";
      
      return str;
    }
}

