/*
 *  Copyright (c) 2001 Regents of the University of California.  All
 *  rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *  3. Neither the name of the University nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS
 *  IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 *  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package ostore.util;

/**
***  <p>
***  This class stores contants by which to refer to stages in the
***  running system.  We use stage identifiers in some messages to
***  provide the classifier a field by which it may filter messages
***  for dispatching to stages.
***  </p>
*** 
***  @author  Patrick R. Eaton
***  @version $Id: StageId.java,v 1.4 2002/03/11 19:33:55 hweather Exp $
**/
public class StageId
{
    static public final int INNER_STAGE                     = 0x1001;
    static public final int READ_STAGE                      = 0x1002;
    static public final int REPLICA_STAGE                   = 0x1003;
    static public final int UPDATE_STAGE                    = 0x1004;

    static public final int GENERATE_CHKPT_STAGE              = 0x1007;
    static public final int GENERATE_FRAGS_STAGE              = 0x1008;
    static public final int RECOALESCE_BLK_STAGE              = 0x1009;
    static public final int REQUESTOR_STAGE                   = 0x100B;
    static public final int DISSEMINATOR_STAGE                = 0x100C;
    static public final int SET_CREATOR_STAGE                 = 0x100D;
    static public final int ARCHIVAL_STORAGE_STAGE            = 0x100E;
    static public final int FAKE_REQUESTOR_DISSEMINATOR_STAGE = 0x100F;
}
