/**
 * VerifiableBlockTag.java
 *
 * @author   Hakim Weatherspoon
 * @version  $Id: VerifiableBlockTag.java,v 1.1 2001/10/10 07:19:06 hweather Exp $
 *
 * Copyright (c) 2001 Regents of the University of California.
 * All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of the University nor the names of its contributors
 *     may be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 *  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *  ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 *  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 *  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 *  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *  SUCH DAMAGE.
 */

package ostore.util;

import ostore.util.Types;
import ostore.tapestry.api.TapestryTag;

/**
 * The Tapestry tag published by object replicas (second-tier and clients).
 * who have a cached copy of a VerifiableBlock
 *
 * @see VerifiableBlock
 *
 * @author   Hakim Weatherspoon
 * @version  $Id: VerifiableBlockTag.java,v 1.1 2001/10/10 07:19:06 hweather Exp $
 */
public class VerifiableBlockTag implements TapestryTag
{
  ////////////////////       CONSTANTS	////////////////////
  ////////////////////    STATIC VARIABLES 	////////////////////
  ////////////////////       VARIABLES	////////////////////
  ////////////////////  STATIC CONSTRUCTORS	////////////////////
  ////////////////////      CONSTRUCTORS	////////////////////

  /**
   * Creates a new <code>VerifiableBlockTag</code>. */
  public VerifiableBlockTag() {}
    
  /**
   * Creates a new <code>VerifiableBlockTag</code> from its
   * <code>QuickSerializable</code> form. */
  public VerifiableBlockTag(byte[] data, int[] offset ) {}
    
  ////////////////////     STATIC METHODS 	////////////////////
  //////////////////// 	METHODS		////////////////////

  /**
   * Specified by ostore.util.QuickSerializable */
  public synchronized void to_bytes(byte [] data, int [] offset ) {}
    
  /**
   * Specified by ostore.util.QuickSerializable */
  public int type_code()
  {
    return ostore.util.Types.VERIFIABLE_BLOCK_TAG;
  }

  ////////////////////     INNER CLASSES	////////////////////
}
